#include <windows.h>
#include <commctrl.h>
#include "resource.h"

const char g_szClassName[] = "myWindowClass";
char helpPath[MAX_PATH];
typedef int (WINAPI*DllFunc)(HANDLE,HWND,HMODULE);

char * getFilterString(HMODULE * dllMods, int numMods);
int strDbTermLen(char * str);
int getModIndx(char * path, int extOff, HMODULE * dllMods, int numMods);
int strLen(char * str);

BOOL CALLBACK AboutDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam) {
switch(Message) {
	case WM_INITDIALOG:
	return TRUE;
	case WM_COMMAND:
	switch(LOWORD(wParam)) {
		case IDOK:
		EndDialog(hwnd, IDOK);
		break;
	}
	break;
	case WM_CLOSE:
	EndDialog(hwnd, 0);
	break;
	default:
	return FALSE;
}
return TRUE;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
static HMODULE * dllMod = 0;
static int dllCount = 0;
switch(msg) {
	case WM_CREATE:
	{
	GetFullPathName("help.chm", MAX_PATH, helpPath, NULL);
	WIN32_FIND_DATA wfd;
	int i;
	HANDLE findFile = FindFirstFile("*.dll", &wfd);
	if (findFile == INVALID_HANDLE_VALUE) {
	MessageBox(hwnd, "No DLL Files Found!\r\nProgram will now exit.", "Error", MB_ICONEXCLAMATION | MB_OK);
	DestroyWindow(hwnd);
	return 0;
	}
	dllCount++;
	bool done = false;
	while(!done) {
	if(!FindNextFile(findFile, &wfd)) {
	if(GetLastError() == ERROR_NO_MORE_FILES) done = true;
	} 
	else dllCount++;
	}
	FindClose(findFile);
	dllMod = new HMODULE[dllCount];
	findFile = FindFirstFile("*.dll", &wfd);
	dllMod[0] = LoadLibrary(wfd.cFileName);
	if (dllCount == 1) break;
	for (i=1;i<dllCount;i++) {
	FindNextFile(findFile, &wfd);
	dllMod[i] = LoadLibrary(wfd.cFileName);
	}
	FindClose(findFile);
	break;
	}
	case WM_COMMAND:
		switch(LOWORD(wParam)) {
			case ID_OPEN:
			{
				OPENFILENAME ofn;
				char szFileName[MAX_PATH] = "";
				ZeroMemory(&ofn, sizeof(ofn));
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = hwnd;
				ofn.lpstrFilter = getFilterString(dllMod, dllCount);
				ofn.lpstrFile = szFileName;
				ofn.nMaxFile = MAX_PATH;
				ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
				if(!GetOpenFileName(&ofn)) {
				return 0;
				}
				HANDLE hFile = CreateFile(szFileName, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, NULL);
				if(hFile == INVALID_HANDLE_VALUE) {
				MessageBox(hwnd, "Couldn't open file!\r\nMake sure no other program\r\nis using the file and try again.", "Error", MB_ICONERROR | MB_OK);
				return 0;
				}
				int ret = getModIndx(szFileName, ofn.nFileExtension, dllMod, dllCount);
				if (ret == -1) {
				MessageBox(hwnd, "Can not find a plugin for the chosen file type.", "Error", MB_OK | MB_ICONEXCLAMATION);
				return 0;
				}
				DllFunc LoadFile = (DllFunc)GetProcAddress(dllMod[ret], "LoadFile");
				LoadFile(hFile, hwnd, dllMod[ret]);
				CloseHandle(hFile);
			}
			break;
			case ID_HELP:
			ShellExecute(hwnd, "open", helpPath, NULL, NULL, SW_SHOWNORMAL);
			break;
			case ID_ABOUT:
				if (DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ABOUT), hwnd, AboutDlgProc) == -1) {
				MessageBox(hwnd, "Dialog failed!", "Error", MB_OK | MB_ICONINFORMATION);
				}
			break;
			case ID_EXIT:
                		PostMessage(hwnd, WM_CLOSE, 0, 0);
			break;
		}
	break;
	case WM_MOVING:
	if (((RECT*)lParam)->left <= 0) {
	((RECT*)lParam)->right = ((RECT*)lParam)->right - ((RECT*)lParam)->left;
	((RECT*)lParam)->left = 0;
	}
	if (((RECT*)lParam)->right >= GetSystemMetrics(SM_CXSCREEN)) {
	((RECT*)lParam)->left = GetSystemMetrics(SM_CXSCREEN) - ((RECT*)lParam)->right + ((RECT*)lParam)->left;
	((RECT*)lParam)->right = GetSystemMetrics(SM_CXSCREEN);
	}
	if (((RECT*)lParam)->top <= 0) {
	((RECT*)lParam)->bottom = ((RECT*)lParam)->bottom - ((RECT*)lParam)->top;
	((RECT*)lParam)->top = 0;
	}
	if (((RECT*)lParam)->bottom >= GetSystemMetrics(SM_CYSCREEN)) {
	((RECT*)lParam)->top = GetSystemMetrics(SM_CYSCREEN) - (((RECT*)lParam)->bottom - ((RECT*)lParam)->top);
	((RECT*)lParam)->bottom = GetSystemMetrics(SM_CYSCREEN);
	}
	break;
	case WM_CLOSE:
		DestroyWindow(hwnd);
	break;
	case WM_DESTROY:
		if (dllMod != 0) {
		int i;
		for(i=0;i<dllCount;i++) FreeLibrary(dllMod[i]);
		}
		delete [] dllMod;
		PostQuitMessage(0);
	break;
	default:
		return DefWindowProc(hwnd, msg, wParam, lParam);
}
return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
WNDCLASSEX wc;
HWND hwnd;
MSG Msg;

wc.cbSize        = sizeof(WNDCLASSEX);
wc.style         = 0;
wc.lpfnWndProc   = WndProc;
wc.cbClsExtra    = 0;
wc.cbWndExtra    = 0;
wc.hInstance     = hInstance;
wc.hIcon         = LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_MAIN));
wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
wc.lpszMenuName  = NULL;
wc.lpszClassName = g_szClassName;
wc.hIconSm       = (HICON)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_MAIN), IMAGE_ICON, 16, 16, 0);

if(!RegisterClassEx(&wc)) {
MessageBox(NULL, "Window Registration Failed!", "Error!", MB_ICONEXCLAMATION | MB_OK);
return 0;
}

hwnd = CreateWindowEx(WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW | WS_EX_APPWINDOW, g_szClassName, "TagEdit", WS_OVERLAPPED | WS_CLIPCHILDREN | WS_SYSMENU | WS_CAPTION | WS_MINIMIZEBOX, GetSystemMetrics(SM_CXSCREEN) / 10, GetSystemMetrics(SM_CYSCREEN) / 10, 500, 400, NULL, NULL, hInstance, NULL);

if(hwnd == NULL) {
MessageBox(NULL, "Window Creation Failed!", "Error!", MB_ICONEXCLAMATION | MB_OK);
return 0;
}
    
INITCOMMONCONTROLSEX icex;
icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
icex.dwICC  = ICC_BAR_CLASSES | ICC_COOL_CLASSES;
InitCommonControlsEx(&icex);

HWND rBar;
rBar = CreateWindowEx(WS_EX_TOOLWINDOW, REBARCLASSNAME, NULL, WS_CHILD | WS_VISIBLE | RBS_VARHEIGHT | RBS_BANDBORDERS | RBS_DBLCLKTOGGLE | CCS_NODIVIDER, 0, 0, 0, 0, hwnd, NULL, GetModuleHandle(NULL), NULL);

REBARINFO rbi;
rbi.cbSize = sizeof(REBARINFO);
rbi.fMask  = 0;
rbi.himl   = (HIMAGELIST)NULL;
SendMessage(rBar, RB_SETBARINFO, 0, (LPARAM)&rbi);

REBARBANDINFO rbBand;
rbBand.cbSize = sizeof(REBARBANDINFO);  // Required
rbBand.fMask  = RBBIM_STYLE | RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_SIZE;
rbBand.fStyle = RBBS_CHILDEDGE | RBBS_GRIPPERALWAYS;

HWND hTool;
hTool = CreateWindowEx(TBSTYLE_EX_MIXEDBUTTONS, TOOLBARCLASSNAME, NULL, WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | TBSTYLE_FLAT | TBSTYLE_LIST | CCS_NODIVIDER | CCS_NORESIZE, 0, 0, 0, 0, hwnd, NULL, GetModuleHandle(NULL), NULL);

SendMessage(hTool, TB_BUTTONSTRUCTSIZE, (WPARAM)sizeof(TBBUTTON), 0);

TBBUTTON tbb[4];
TBADDBITMAP tbab;

tbab.hInst = GetModuleHandle(NULL);
tbab.nID = IDB_TOOLIMG;
SendMessage(hTool, TB_ADDBITMAP, 4, (LPARAM)&tbab);

char iStrings[] = "Open\0Help\0About\0Exit\0";

SendMessage(hTool, TB_ADDSTRING, NULL, (LPARAM)iStrings);

ZeroMemory(tbb, sizeof(tbb));
tbb[0].iBitmap = 0;
tbb[0].fsState = TBSTATE_ENABLED;
tbb[0].fsStyle = BTNS_BUTTON;
tbb[0].idCommand = ID_OPEN;
tbb[0].iString = 0;

tbb[1].iBitmap = 1;
tbb[1].fsState = TBSTATE_ENABLED;
tbb[1].fsStyle = BTNS_BUTTON;
tbb[1].idCommand = ID_HELP;
tbb[1].iString = 1;

tbb[2].iBitmap = 2;
tbb[2].fsState = TBSTATE_ENABLED;
tbb[2].fsStyle = BTNS_BUTTON;
tbb[2].idCommand = ID_ABOUT;
tbb[2].iString = 2;

tbb[3].iBitmap = 3;
tbb[3].fsState = TBSTATE_ENABLED;
tbb[3].fsStyle = BTNS_BUTTON;
tbb[3].idCommand = ID_EXIT;
tbb[3].iString = 3;

SendMessage(hTool, TB_ADDBUTTONS, sizeof(tbb)/sizeof(TBBUTTON), (LPARAM)&tbb);

rbBand.hwndChild  = hTool;
rbBand.cxMinChild = 100;
rbBand.cyMinChild = HIWORD(SendMessage(hTool, TB_GETBUTTONSIZE, 0, 0));
rbBand.cx         = 250;

SendMessage(rBar, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbBand);

RECT rectClient, rectWindow;
UINT windowWidth, windowHeight, clientWidth, clientHeight;

GetWindowRect(hwnd, &rectWindow);
GetClientRect(hwnd, &rectClient);

rbBand.fMask = RBBIM_HEADERSIZE;
SendMessage(rBar, RB_GETBANDINFO, (WPARAM)0, (LPARAM)&rbBand); 
clientWidth = LOWORD(SendMessage(hTool, TB_GETBUTTONSIZE, 0, 0)) * SendMessage(hTool, TB_BUTTONCOUNT, 0, 0) + rbBand.cxHeader + 5;
clientHeight = SendMessage(rBar, RB_GETBARHEIGHT, 0, 0);

windowWidth = ((rectWindow.right - rectWindow.left) - rectClient.right) + clientWidth;
windowHeight = ((rectWindow.bottom - rectWindow.top) - rectClient.bottom) + clientHeight;

SetWindowPos(hwnd, NULL, 0, 0, windowWidth, windowHeight, SWP_NOZORDER | SWP_NOMOVE);

ShowWindow(hwnd, nCmdShow);
UpdateWindow(hwnd);

while(GetMessage(&Msg, NULL, 0, 0) > 0) {
TranslateMessage(&Msg);
DispatchMessage(&Msg);
}
return Msg.wParam;
}

char * getFilterString(HMODULE * dllMods, int numMods) {
char * out = 0;
int i,j;
int len = 0;
for (i=0;i<numMods;i++) {
len += strDbTermLen((char *)GetProcAddress(dllMods[i], "filterStr"));
}
out = new char[len + 22];
int curSpot = 0;
for (i=0;i<numMods;i++) {
char * temp = (char *)GetProcAddress(dllMods[i], "filterStr");
for (j=0;j<strDbTermLen(temp);j++) {
out[curSpot] = temp[j];
curSpot++;
}}
for (j=0;j<21;j++) {
out[curSpot] = "All Files (*.*)\0*.*\0"[j];
curSpot++;
}
out[len + 21] = '\0';
return out;
}

int strDbTermLen(char * str) {
int i;
for (i=0;i<100;i++) {
if (str[i] == '\0' && str[i+1] == '\0') return i + 1;
}
return -1;
}

int getModIndx(char * path, int extOff, HMODULE * dllMods, int numMods) {
int i,j,k;
for (i=0;i<numMods;i++) {
bool thisOne = false;
char * temp = (char *)GetProcAddress(dllMods[i], "filterStr");
int tem = 0;
for (j=0;j<strDbTermLen(temp);j++) {
if (temp[j] == '\0') tem++;
}
int * zeroIndices = new int[tem/2];
int currInd = 0;
int numPairs;
for (j=0;j<strDbTermLen(temp);j++) {
if (temp[j] == '\0') {
if (currInd % 2 == 0) zeroIndices[currInd / 2] = j;
currInd++;
}}
for (j=0;j<(tem)/2;j++) {
for (k=0;k<strLen(path)-extOff;k++) {
if(temp[zeroIndices[j] + k + 3] == path[extOff + k]) thisOne = true;
else thisOne = false;
}
if (thisOne) {
delete [] zeroIndices;
return i;
}}
delete [] zeroIndices;
}
return -1;
}

int strLen(char * str) {
int i;
for (i=0;1;i++) {
if (str[i] == '\0') return i;
}}
